
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Qa_resultsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.create(
            {
                id: data.id || undefined,
        
        measured_value: data.measured_value
        ||
        null
            ,
            
        attribute_result: data.attribute_result
        ||
        null
            ,
            
        within_limits: data.within_limits
        ||
        false
        
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await qa_results.setQa_inspection( data.qa_inspection || null, {
            transaction,
        });
        
        await qa_results.setCharacteristic( data.characteristic || null, {
            transaction,
        });
        

        

        

        return qa_results;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const qa_resultsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                measured_value: item.measured_value
            ||
            null
            ,
            
                attribute_result: item.attribute_result
            ||
            null
            ,
            
                within_limits: item.within_limits
            ||
            false
        
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const qa_results = await db.qa_results.bulkCreate(qa_resultsData, { transaction });

        // For each item created, replace relation files
        

        return qa_results;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const qa_results = await db.qa_results.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.measured_value !== undefined) updatePayload.measured_value = data.measured_value;
        
        
        if (data.attribute_result !== undefined) updatePayload.attribute_result = data.attribute_result;
        
        
        if (data.within_limits !== undefined) updatePayload.within_limits = data.within_limits;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await qa_results.update(updatePayload, {transaction});

        
        
        if (data.qa_inspection !== undefined) {
            await qa_results.setQa_inspection(
              
              data.qa_inspection,
              
              { transaction }
            );
        }
        
        if (data.characteristic !== undefined) {
            await qa_results.setCharacteristic(
              
              data.characteristic,
              
              { transaction }
            );
        }
        

        
        

        

        return qa_results;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of qa_results) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of qa_results) {
                await record.destroy({transaction});
            }
        });


        return qa_results;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findByPk(id, options);

        await qa_results.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await qa_results.destroy({
            transaction
        });

        return qa_results;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const qa_results = await db.qa_results.findOne(
            { where },
            { transaction },
        );

        if (!qa_results) {
            return qa_results;
        }

        const output = qa_results.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.qa_inspection = await qa_results.getQa_inspection({
            transaction
        });
        
        
        output.characteristic = await qa_results.getCharacteristic({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.qa_inspections,
        as: 'qa_inspection',
        
        where: filter.qa_inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.qa_inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              inspection_number: {
                [Op.or]: filter.qa_inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.qa_characteristics,
        as: 'characteristic',
        
        where: filter.characteristic ? {
          [Op.or]: [
            { id: { [Op.in]: filter.characteristic.split('|').map(term => Utils.uuid(term)) } },
            {
              characteristic_name: {
                [Op.or]: filter.characteristic.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_results',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.measured_valueRange) {
                const [start, end] = filter.measured_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    measured_value: {
                    ...where.measured_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    measured_value: {
                    ...where.measured_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.attribute_result) {
                where = {
                    ...where,
                attribute_result: filter.attribute_result,
            };
            }
            
            if (filter.within_limits) {
                where = {
                    ...where,
                within_limits: filter.within_limits,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.qa_results.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'qa_results',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.qa_results.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

